%bcond_without gtkdoc
%bcond_with bootstrap
%bcond_with tests

%define pkgname gtk+
%define binary_version 2.10.0

%define api 2.0
%define major 0
%define libname %mklibname %{pkgname} %{api} %{major}
%define devname %mklibname %{pkgname} %{api} -d
# this isnt really a true lib pkg, but a modules/plugin pkg
%define modules %mklibname gtk-modules %{api}

%define gail_major 18
%define libgail %mklibname gail %{gail_major}
%define devgail %mklibname gail -d

%define girname %mklibname gtk-gir %{api}

Summary:	The GIMP ToolKit (GTK+), a library for creating GUIs
Name:		%{pkgname}%{api}
Version:	2.24.30
Release:	1
License:	LGPLv2+
Group:		System/Libraries
Url:		http://www.gtk.org
Source0:	http://ftp.gnome.org/pub/GNOME/sources/gtk+/2.24/%{pkgname}-%{version}.tar.xz
# extra IM modules (vietnamese and tamil) -- pablo
#gw TODO, needs to be fixed for 2.21.3
Patch0:		gtk+-2.13.1-extra_im.patch
# (fc) 2.0.6-8mdk fix infinite loop and crash in file selector when / and $HOME are not readable (bug #90)
Patch1:		gtk+-2.6.9-fileselectorfallback.patch
# (fwang) 2.22.1-3 use elementary theme by default if available
Patch2:		gtk+-defaulttheme.patch
# (fc) 2.20.0-2mdv allow window dragging toolbars / menubar (GNOME bug #611313)
Patch3:		gtk+-2.24.7-window-dragging.patch
# (fc) 2.20.0-3mdv allow specifying icon padding for tray icon (GNOME bug #583273) (Fedora)
Patch4:		gtk+-2.20.0-icon-padding.patch

BuildRequires:	cups-devel
BuildRequires:	fam-devel
BuildRequires:	gettext-devel
BuildRequires:	pkgconfig(atk)
BuildRequires:	pkgconfig(cairo)
BuildRequires:	pkgconfig(gdk-pixbuf-2.0)
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(gobject-introspection-1.0)
BuildRequires:	pkgconfig(pango)
BuildRequires:	pkgconfig(pangocairo)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xcomposite)
BuildRequires:	pkgconfig(xcursor)
BuildRequires:	pkgconfig(xdamage)
BuildRequires:	pkgconfig(xext)
BuildRequires:	pkgconfig(xfixes)
BuildRequires:	pkgconfig(xi)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	pkgconfig(xrandr)
BuildRequires:	pkgconfig(xrender)
%if %{with tests}
BuildRequires:	x11-server-xvfb
# gw tests will fail without this
BuildRequires:	fonts-ttf-dejavu
%endif
%if %{with gtkdoc}
BuildRequires:	gtk-doc
BuildRequires:	sgml-tools
BuildRequires:	texinfo
%endif
Requires:	%{name}-common = %{EVRD}
# MD to pull in all the orphaned module loaders
Requires:	fontconfig
Requires:	gdk-pixbuf2.0
Requires:	gio2.0
Requires:	pango-modules
# required for icon theme apis to work
Requires:	hicolor-icon-theme
# built as a subpackage of gtk3
Requires:	gtk-update-icon-cache
%if %{without bootstrap}
Suggests:	xdg-user-dirs-gtk
Suggests:	elementary-theme
%endif
Provides:	gtk2 = %{EVRD}
Provides:	%{pkgname}2 = %{EVRD}
Obsoletes:	%{pkgname}2 < %{EVRD}

%description
The gtk+ package contains the GIMP ToolKit (GTK+), a library for creating
graphical user interfaces for the X Window System.  GTK+ was originally
written for the GIMP (GNU Image Manipulation Program) image processing
program, but is now used by several other programs as well.

If you are planning on using the GIMP or another program that uses GTK+,
you'll need to have the gtk+ package installed.

%files
%doc README
%{_bindir}/gtk-query-immodules-%{api}

#----------------------------------------------------------------------------

%package common
Summary:	The GIMP ToolKit (GTK+), a library for creating GUIs
Group:		System/Libraries
Requires:	%{modules} = %{EVRD}
Requires:	gtk2-modules = %{EVRD}
BuildArch:	noarch

%description common
This package contains the common files for the GTK+2.0 graphical user
interface.

%files common -f gtk20.lang
%{_datadir}/themes/
%dir %{_sysconfdir}/gtk-%{api}
%config(noreplace) %{_sysconfdir}/gtk-%{api}/im-multipress.conf

#----------------------------------------------------------------------------

%package -n %{modules}
Summary:	The GIMP ToolKit (GTK+), a library for creating GUIs
Group:		System/Libraries
Requires:	%{name} = %{EVRD}
Provides:	gtk2-modules = %{EVRD}
%if %{without bootstrap}
Suggests:	%{_lib}gtk-aurora-engine
%endif

%description -n %{modules}
This package contains the immodules, engines and printbackends libraries 
for %{name} to function properly.

%files -n %{modules}
%ghost %verify (not md5 mtime size) %config(noreplace) %{_sysconfdir}/gtk-%{api}/gtk.immodules.%{_lib}
%dir %{_libdir}/gtk-%{api}
%dir %{_libdir}/gtk-%{api}/bin
%{_libdir}/gtk-%{api}/bin/gtk-query-immodules-%{api}
%dir %{_libdir}/gtk-%{api}/modules
%dir %{_libdir}/gtk-%{api}/%{binary_version}
%dir %{_libdir}/gtk-%{api}/%{binary_version}/immodules
%dir %{_libdir}/gtk-%{api}/%{binary_version}/engines
%dir %{_libdir}/gtk-%{api}/%{binary_version}/printbackends
%{_libdir}/gtk-%{api}/%{binary_version}/immodules/*.so
%{_libdir}/gtk-%{api}/%{binary_version}/engines/*.so
%{_libdir}/gtk-%{api}/%{binary_version}/printbackends/*.so
# from gail lib
%{_libdir}/gtk-2.0/modules/libferret.so
%{_libdir}/gtk-2.0/modules/libgail.so

%post -n %{modules}
if [ "$1" = "2" ]; then
  if [ -f %{_sysconfdir}/gtk-%{api}/gtk.immodules ]; then
    rm -f %{_sysconfdir}/gtk-%{api}/gtk.immodules
  fi
fi
%{_libdir}/gtk-%{api}/bin/gtk-query-immodules-%{api} > %{_sysconfdir}/gtk-%{api}/gtk.immodules.%{_lib}

%triggerin -n %{modules} -- %{_libdir}/gtk-%{api}/%{binary_version}/immodules/*.so
%{_libdir}/gtk-%{api}/bin/gtk-query-immodules-%{api} > %{_sysconfdir}/gtk-%{api}/gtk.immodules.%{_lib}

%triggerpostun -n %{modules} -- %{_libdir}/gtk-%{api}/%{binary_version}/immodules/*.so
if [ -x %{_libdir}/gtk-%{api}/bin/gtk-query-immodules-%{api} ]; then %{_libdir}/gtk-%{api}/bin/gtk-query-immodules-%{api} > %{_sysconfdir}/gtk-%{api}/gtk.immodules.%{_lib}
fi

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	X11 backend of The GIMP ToolKit (GTK+)
Group:		System/Libraries

%description -n %{libname}
This package contains the X11 version of library needed to run
programs dynamically linked with gtk+.

%files -n %{libname}
%{_libdir}/libgdk-x11-%{api}.so.%{major}*
%{_libdir}/libgtk-x11-%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{girname}
Summary:	GObject Introspection interface description for %{name}
Group:		System/Libraries
Conflicts:	gir-repository < 0.6.5-4

%description -n %{girname}
GObject Introspection interface description for %{name}.

%files -n %{girname}
%{_libdir}/girepository-1.0/Gdk-%{api}.typelib
%{_libdir}/girepository-1.0/GdkX11-%{api}.typelib
%{_libdir}/girepository-1.0/Gtk-%{api}.typelib

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Development files for GTK+ (GIMP ToolKit) applications
Group:		Development/GNOME and GTK+
Requires:	%{libname} = %{EVRD}
Requires:	%{girname} = %{EVRD}
Provides:	gtk2-devel = %{EVRD}
Provides:	%{pkgname}2-devel = %{EVRD}
Provides:	lib%{pkgname}%{api}-devel = %{EVRD}
Provides:	%{libname}-devel = %{EVRD}

%description -n %{devname}
The libgtk+-devel package contains the static libraries and header files
needed for developing GTK+ (GIMP ToolKit) applications. The libgtk+-devel
package contains GDK (the General Drawing Kit, which simplifies the interface
for writing GTK+ widgets and using GTK+ widgets in applications), and GTK+
(the widget set).

%files -n %{devname}
%doc docs/*.txt AUTHORS ChangeLog NEWS* README*
%doc %{_datadir}/gtk-doc/html/gdk2/
%doc %{_datadir}/gtk-doc/html/gtk2/
%{_bindir}/gtk-demo
%{_bindir}/gtk-builder-convert
%{_datadir}/aclocal/*
%{_datadir}/gtk-%{api}/
%{_includedir}/gtk-unix-print-%{api}/
%{_includedir}/gtk-%{api}/gdk
%{_includedir}/gtk-%{api}/gtk
%{_libdir}/gtk-%{api}/include
%{_libdir}/pkgconfig/gdk-%{api}.pc
%{_libdir}/pkgconfig/gtk+-%{api}.pc
%{_libdir}/pkgconfig/gtk+-unix-print-%{api}.pc
%{_libdir}/libgdk-x11-%{api}.so
%{_libdir}/libgtk-x11-%{api}.so
%{_datadir}/gir-1.0/Gdk-2.0.gir
%{_datadir}/gir-1.0/GdkX11-2.0.gir
%{_datadir}/gir-1.0/Gtk-2.0.gir
%{_libdir}/pkgconfig/*x11*

#----------------------------------------------------------------------------

%package -n %{libgail}
Summary:	GNOME Accessibility Implementation Library
Group:		System/Libraries

%description -n %{libgail}
Gail is the GNOME Accessibility Implementation Library

%files -n %{libgail}
%{_libdir}/libgailutil.so.%{gail_major}*

#----------------------------------------------------------------------------

%package -n %{devgail}
Summary:	Development libraries, include files for GAIL
Group:		Development/GNOME and GTK+
Requires:	%{libgail} = %{EVRD}
Provides:	gail-devel = %{EVRD}

%description -n %{devgail}
Gail is the GNOME Accessibility Implementation Library

%files -n %{devgail}
%{_datadir}/gtk-doc/html/gail-libgail-util
%{_libdir}/libgailutil.so
%{_includedir}/gail-1.0/
%{_libdir}/pkgconfig/gail.pc

#----------------------------------------------------------------------------

%prep
%setup -qn %{pkgname}-%{version}
%apply_patches

#needed by patches 4 & 13
#gw disable it for bootstrapping
mkdir -p m4
autoreconf -fi

%build
# fix crash in nautilus (GNOME bug #596977)
export CFLAGS=`echo %{optflags} | sed -e 's/-fomit-frame-pointer//g'`

#CONFIGURE_TOP=.. 
export CPPFLAGS="-DGTK_COMPILATION"
%configure2_5x \
	--disable-static \
	--enable-xinerama \
	--with-xinput=xfree

%make

%install
%makeinstall_std mandir=%{_mandir} RUN_QUERY_IMMODULES_TEST=false RUN_QUERY_LOADER_TEST=false

mkdir -p %{buildroot}%{_sysconfdir}/gtk-%{api}
touch %{buildroot}%{_sysconfdir}/gtk-%{api}/gtk.immodules.%{_lib}
mkdir -p %{buildroot}%{_libdir}/gtk-%{api}/modules

# Remove unpackaged files
rm -f %{buildroot}%{_bindir}/gtk-update-icon-cache
rm -f %{buildroot}%{_mandir}/man1/gtk-update-icon-cache.1*

# handle biarch packages
progs="gtk-query-immodules-%{api}"
mkdir -p %{buildroot}%{_libdir}/gtk-%{api}/bin
for f in $progs; do
  mv -f %{buildroot}%{_bindir}/$f %{buildroot}%{_libdir}/gtk-%{api}/bin/
  cat > %{buildroot}%{_bindir}/$f << EOF
#!/bin/sh
lib=%{_lib}
case ":\$1:" in
:lib*:) lib="\$1"; shift 1;;
esac
exec %{_prefix}/\$lib/gtk-%{api}/bin/$f \${1+"\$@"}
EOF
  chmod +x %{buildroot}%{_bindir}/$f
done

%find_lang gtk20
%find_lang gtk20-properties
cat gtk20-properties.lang >> gtk20.lang

%check
%if %{with tests}
XDISPLAY=$(i=1; while [ -f /tmp/.X$i-lock ]; do i=$(($i+1)); done; echo $i)
%{_bindir}/Xvfb :$XDISPLAY &
export DISPLAY=:$XDISPLAY
make check
kill $(cat /tmp/.X$XDISPLAY-lock) ||:
%endif

%changelog
